routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    if (Auth::check())
        return redirect()->route('home');
    else
        return redirect()->route('login');
});

// Register login, register, password-reset, and other lovely core stuff.
Auth::routes();

Route::get('register/thanks', 'Auth\RegisterController@thanks')->name('register.thanks');
Route::get('register/to/{city_slug}/{section_id}', 'Auth\RegisterController@sectionPreload')->name('register.tosection');

Route::middleware(['auth'])->group(function () {
    Route::get('home', 'HomeController@index')->name('home');

    Route::post('user/approve', 'UserController@approve')->name('user.approve');
    Route::get('user/bypass/{id}', 'UserController@bypass')->name('user.bypass');

    Route::get('movement/review', 'MovementController@review')->name('movement.review');
    Route::post('movement/attach/{id}', 'MovementController@attach')->name('movement.attach');
    Route::post('movement/refund/{id}', 'MovementController@refund')->name('movement.refund');
    Route::get('movement/download', 'MovementController@download')->name('movement.download');

    Route::get('section/{id}/balance', 'SectionController@balance')->name('section.balance');
    Route::post('section/{id}/exportmembers', 'SectionController@exportmembers')->name('section.exportmembers');

    Route::get('refund/download', 'RefundController@download')->name('refund.download');

    Route::get('sponsor/logo/{id}', 'SponsorController@logo')->name('sponsor.logo');

    Route::get('doc/download', 'DocumentationController@download')->name('doc.download');
    Route::get('doc/link', 'DocumentationController@link')->name('doc.link');
    Route::get('doc/preview', 'DocumentationController@preview')->name('doc.preview');

    Route::post('assembly/partecipate/{assembly_id}/{do}', 'AssemblyController@partecipate')->name('assembly.partecipate');
    Route::post('assembly/delegate/{assembly_id}/{delegate_id}', 'AssemblyController@delegate')->name('assembly.delegate');

    Route::get('bank/list/', 'BankController@list')->name('bank.list_all');
    Route::get('bank/list/{id}', 'BankController@list')->name('bank.list');

    Route::resource('user', 'UserController');
    Route::resource('volunteer', 'VolunteerController');
    Route::resource('doc', 'DocumentationController');
    Route::resource('config', 'ConfigController');
    Route::resource('bank', 'BankController');
    Route::resource('movement', 'MovementController');
    Route::resource('rule', 'RuleController');
    Route::resource('section', 'SectionController');
    Route::resource('receipt', 'ReceiptController');
    Route::resource('refund', 'RefundController');
    Route::resource('assembly', 'AssemblyController');
    Route::resource('votation', 'VotationController');
    Route::resource('vote', 'VoteController');
    Route::resource('sponsor', 'SponsorController');
});

app/Section.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Support\Str;

class Section extends Model
{
    // https://laravel.com/docs/11.x/eloquent#soft-deleting
    use SoftDeletes;

    /**
     * Get the City "slug".
     * This should NOT be considered an index of any kind.
     * It was designed just for URL-cosmetic reasons.
     *
     * @return string
     */
    public function getCitySlugAttribute()
    {
        return Str::slug($this->city);
    }

    /**
     * Get the URL that describes the Registration page,
     * with this Section preloaded.
     *
     * @return string
     */
    public function getRegisterToSectionURLAttribute()
    {
        return route('register.tosection', [
            'section_id' => $this->id,
            'city_slug' => $this->citySlug,
        ]);
    }

    public function users()
    {
        return $this->hasMany('App\User');
    }

    public function volunteers()
    {
        return $this->hasMany('App\Volunteer');
    }

    public function economic_logs()
    {
        return $this->hasMany('App\EconomicLog');
    }

    public function alterBalance($amount, $account_row, $reason)
    {
        $this->balance += $amount;
        $this->save();

        $log = new EconomicLog;
        $log->section_id = $this->id;
        $log->amount = $amount;
        $log->account_row_id = $account_row ? $account_row->id : 0;
        $log->reason = $reason;
        $log->save();
    }
}

app/Http/Controllers/SectionController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use DB;

use App\Section;
use App\User;
use App\Role;
use App\Volunteer;

class SectionController extends EditController
{
    public function __construct()
    {
        parent::init([
            'classname' => 'App\Section',
            'view_folder' => 'section'
        ]);
    }

    protected function defaultValidations($object)
    {
        return [
            'city' => 'required|max:255',
            'prov' => 'required|max:2',
        ];
    }

    protected function requestToObject($request, $object)
    {
        $object->city = $request->input('city');
        $object->prov = $request->input('prov');
        return $object;
    }

    protected function defaultSortingColumn()
    {
        return 'city';
    }

    public function update(Request $request, $id)
    {
        $currentuser = $request->user();
        $section = Section::find($id);
        $this->authorize('update', $section);

        if ($request->has('user')) {
            $users = $request->input('user');
            $roles = $request->input('role');
            $referent_role = Role::where('name', 'referent')->first();

            for ($i = 0; $i < count($users); $i++) {
                $u = $users[$i];
                $r = $roles[$i];

                $user = User::find($u);

                if ($currentuser->hasRole('admin') || $user->section_id == $currentuser->section_id) {
                    if ($r == 'referent') {
						if ($user->hasRole('referent') == false) {
							$user->roles()->attach($referent_role->id);
						}
                    }
                    else {
                        $user->roles()->detach($referent_role->id);
                    }
                }
            }

            return redirect()->route($this->view_folder . '.edit', $id);
        }
        else if ($request->has('volunteer')) {
            $volunteers = $request->input('volunteer');
            $names = $request->input('name');
            $surnames = $request->input('surname');
            $emails = $request->input('email');
            $to_remove = $request->input('remove', []);

            for ($i = 0; $i < count($volunteers); $i++) {
                $v = $volunteers[$i];
                $n = $names[$i];
                $s = $surnames[$i];
                $e = $emails[$i];

                $volunteer = Volunteer::find($v);

                if (in_array($v, $to_remove)) {
                    if ($currentuser->can('delete', $volunteer))
                        $volunteer->delete();
                }
                else {
                    if ($currentuser->can('update', $volunteer)) {
                        $volunteer->name = $n;
                        $volunteer->surname = $s;
                        $volunteer->email = $e;
                        $volunteer->save();
                    }
                }
            }

            return redirect()->route($this->view_folder . '.edit', $id);
        }
        else {
            return parent::update($request, $id);
        }
    }

    public function balance(Request $request, $id)
    {
        $section = Section::find($id);
        $this->authorize('view', $section);

        $year = $request->input('year', date('Y'));
        $rows = $section->economic_logs()->where(DB::raw('YEAR(created_at)'), $year)->orderBy('created_at', 'desc')->get();

        return view('section.balance', compact('section', 'year', 'rows'));
    }

    /**
     * Generate a CSV file from the visible members
     * This can be useful, for example, to bulk-email people
     * So, for commodity reasons, a public e-mail address is exported too.
     */
    public function exportMembers(Request $request, $id) {
        $section = Section::find($id);

        // this is probably too much strict for just viewing some public info
        // but I don't want to overthing
        $this->authorize('update', $section);

        // avoid to break the CSV
        \Debugbar::disable();

        // create a temporary file to build a nice CSV file
        $csv_handle = fopen('php://memory', 'r+');
        if($csv_handle === false) {
            throw new Exception("Cannot create file");
        }

        // HTTP headers to render a CSV file
        header("Content-Type: text/csv; charset=UTF-8");
        header("Content-Disposition: attachment; filename=members.csv");

        $csv_header = [
            'UserID',
            'UserNick',
            'UserPublicMail',
            'UserName',
            'UserSurname',
            'UserIsReferent',
        ];
        fputcsv($csv_handle, $csv_header);

        foreach($section->users as $user) {

            $is_referent = $user->hasRole('referent');
            $is_referent_human = $is_referent ? 'Y' : 'N';

            // CSV row
            // all of these are public info that can be disclosed to section coordinators
            $csv_row = [
                $user->id,
                $user->username,
                // The Custom Email is a Public Email that can be shared at least to section coordinators.
                // For privacy reasons we do not export the private e-mail here, but that could change after further discussions about data protection.
                $user->custom_email,
                $user->name,
                $user->surname,
                $is_referent_human,
            ];
            fputcsv($csv_handle, $csv_row);
        }

        // Render the output
        // I copy-pasted this from something else,
        // I have not a strong opinion about this,
        // so, feel free to replace if you have a better approach
        // This seems horrible to me but hey, it works.
        // -- boz, 2023-05-18
        rewind($csv_handle);
        $output = stream_get_contents($csv_handle);
        fclose($csv_handle);

        return $output;
    }

}

resources/views/section/balance.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <nav class="nav">
        @foreach(App\EconomicLog::selectRaw('YEAR(created_at) as year')->where('section_id', $section->id)->distinct()->orderBy('year', 'asc')->pluck('year') as $nav_year)
            <a class="nav-link {{ $year == $nav_year ? 'active' : '' }}" href="{{ route('section.balance', ['id' => $section->id, 'year' => $nav_year]) }}">{{ $nav_year }}</a>
        @endforeach
    </nav>

    <div class="row mt-3">
        <div class="col-md-12">
            <table class="table">
                <thead>
                    <tr>
                        <th>Data</th>
                        <th>Valore</th>
                        <th>Causale</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach($rows as $row)
                        <tr>
                            <td>{{ $row->created_at }}</td>
                            <td>{{ $row->amount }}</td>
                            <td>{{ $row->reason }}</td>
                        </tr>
                    @endforeach
                </tbody>
            </table>
        </div>
    </div>
</div>
@endsection

resources/views/section/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            @if($currentuser->hasRole('admin'))
                <form method="POST" action="{{ route('section.update', $object->id) }}">
                    @method('PUT')
                    @csrf

                    @include('section.form', ['object' => $object])

                    <div class="form-group row">
                        <div class="col-sm-10">
                            <button type="submit" class="btn btn-primary">Salva</button>
                        </div>
                    </div>
                </form>
            @endif

            <div class="card mt-3">
                <div class="card-header">Contabilità</div>

                <div class="card-body">
                    <div class="alert alert-info">
                        Disponibilità Attuale: {{ $object->balance }} €
                    </div>

                    @if($object->economic_logs()->count() != 0)
                        <table class="table">
                            <thead>
                                <tr>
                                    <th>Data</th>
                                    <th>Ammontare</th>
                                    <th>Causale</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach($object->economic_logs()->orderBy('created_at', 'desc')->take(10)->get() as $log)
                                    <tr>
                                        <td>{{ $log->created_at }}</td>
                                        <td>{{ $log->amount }}</td>
                                        <td>{{ $log->reason }}</td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>

                        <a class="btn btn-secondary" href="{{ route('section.balance', $object->id) }}">Consulta lo storico integrale</a>
                    @endif
                </div>
            </div>

            <div class="card mt-3">
                <div class="card-header">Soci</div>

                <div class="card-body">
                    @if($object->users->count() == 0)
                        <div class="alert alert-danger">
                            Non ci sono soci affiliati a questa sezione locale.
                        </div>
                    @else
                        <form method="POST" action="{{ route('section.update', $object->id) }}">
                            @method('PUT')
                            @csrf

                            <table class="table">
                                <thead>
                                    <tr>
                                        <th>Nome</th>
                                        <th>Cognome</th>
                                        <th>Ruolo</th>
                                        @if($currentuser->hasRole('referent') || $currentuser->hasRole('admin'))
                                        <th>Quota pagata</th>
                                        <th>Ultima Quota</th>
                                        @endif
                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach($object->users as $user)
                                        <tr>
                                            <td>{{ $user->name }}</td>
                                            <td>{{ $user->surname }}</td>
                                            <td>
                                                @can('update', $object)
                                                    <input type="hidden" name="user[]" value="{{ $user->id }}">
                                                    <select class="form-control" name="role[]">
                                                        <option value="referent" {{ $user->hasRole('referent') ? 'selected' : '' }}>Referente</option>
                                                        <option value="member" {{ $user->hasRole('referent') == false ? 'selected' : '' }}>Affiliato</option>
                                                    </select>
                                                @else
                                                    @if($user->hasRole('referent'))
                                                        Referente
                                                    @else
                                                        Affiliato
                                                    @endif
                                                @endcan
                                            </td>
                                            @if($currentuser->hasRole('referent') || $currentuser->hasRole('admin'))
                                            <td>{{ $user->fees()->max('year') >= date('Y') ? 'SI' : 'NO' }}</td>
                                            <td>{{ $user->fees()->max('year') }}</td>
                                            @endif
                                        </tr>
                                    @endforeach
                                </tbody>
                            </table>

                            @can('update', $object)
                                <div class="form-group row">
                                    <div class="col-sm-10">
                                        <button type="submit" class="btn btn-primary">Salva</button>
                                    </div>
                                </div>
                            @endcan

                        </form>

                        <div class="row">

                            @can('update', $object)
                            <div class="col-sm-6">
                                <form class="mt-3" method="POST" action="{{ route('section.exportmembers', $object->id) }}">
                                    @csrf
                                    <button type="submit" class="btn btn-secondary">Esporta Contatti (CSV)</button>
                                </form>
                            </div>
                            @endcan

                        </div>
                    @endif
                </div>
            </div>

            <div class="card mt-3">
                <div class="card-header">URL di Invito</div>
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-12">
                            <p><small>Con questo indirizzo le persone potranno associarsi direttamente in questa sezione locale.<br />
                                      Parte della loro quota associativa finirà nella cassa della sezione locale ma senza alcuna spesa aggiuntiva per l'utente finale.</small>
                            </p>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="oi oi-share"></i></span>
                                </div>
                                <input id="register-to-section-url" type="text" value="{{ $object->registerToSectionURL }}" class="form-control" />
                            </div>
                       </div>
                   </div>
                </div>
            </div>

            <div class="card mt-3">
                <div class="card-header">Altri Volontari</div>

                <div class="card-body">
                    @can('update', $object)
                        <div class="row">
                            <div class="col-md-12">
                                <p>
                                    Qui puoi aggiungere e rimuovere persone che, pur non essendo soci, partecipano all'attività della tua sezione locale. È importante mantenere aggiornata questa lista nel tempo, in quanto i volontari qui iscritti sono soggetti alla copertura assicurativa.
                                </p>

                                <button type="button" class="btn btn-secondary" data-toggle="modal" data-target="#createVolunteer">Registra Volontario</button>
                                <div class="modal fade" id="createVolunteer" tabindex="-1" role="dialog">
                                    <div class="modal-dialog modal-lg" role="document">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title">Registra Volontario</h5>
                                                <button type="button" class="close" data-dismiss="modal">
                                                    <span>&times;</span>
                                                </button>
                                            </div>
                                            <form method="POST" action="{{ route('volunteer.store') }}">
                                                @csrf
                                                <div class="modal-body">
                                                    @include('volunteer.form', ['object' => null, 'section_id' => $object->id])
                                                </div>
                                                <div class="modal-footer">
                                                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Annulla</button>
                                                    <button type="submit" class="btn btn-primary">Salva</button>
                                                </div>
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <br>
                    @endif

                    @if($object->volunteers->count() == 0)
                        <div class="alert alert-danger">
                            Non ci sono volontari in questa sezione locale.
                        </div>
                    @else
                        <form method="POST" action="{{ route('section.update', $object->id) }}">
                            @method('PUT')
                            @csrf

                            <table class="table">
                                <thead>
                                    <tr>
                                        <th>Cognome</th>
                                        <th>Nome</th>
                                        <th>Email</th>

                                        @can('update', $object)
                                            <th>Elimina</th>
                                        @endcan
                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach($object->volunteers as $volunteer)
                                        <tr>
                                            @can('update', $object)
                                                <td>
                                                    <input type="hidden" name="volunteer[]" value="{{ $volunteer->id }}">
                                                    <input type="text" class="form-control" name="name[]" value="{{ $volunteer->name }}">
                                                </td>
                                                <td><input type="text" class="form-control" name="surname[]" value="{{ $volunteer->surname }}"></td>
                                                <td><input type="text" class="form-control" name="email[]" value="{{ $volunteer->email }}"></td>
                                                <td><input type="checkbox" name="remove[]" value="{{ $volunteer->id }}"></td>
                                            @else
                                                <td>{{ $volunteer->name }}</td>
                                                <td>{{ $volunteer->surname }}</td>
                                                <td>{{ $volunteer->email }}</td>
                                            @endcan
                                        </tr>
                                    @endforeach
                                </tbody>
                            </table>

                            @can('update', $object)
                                <div class="form-group row">
                                    <div class="col-sm-10">
                                        <button type="submit" class="btn btn-primary">Salva</button>
                                    </div>
                                </div>
                            @endcan
                        </form>
                    @endif
                </div>
            </div>

            @can('delete', $object)
                <form class="mt-3" method="POST" action="{{ route('section.destroy', $object->id) }}">
                    @method('DELETE')
                    @csrf

                    <div class="form-group row">
                        <div class="col-sm-10">
                            <button type="submit" class="btn btn-danger">Elimina Sezione Locale</button>
                        </div>
                    </div>
                </form>
            @endcan
        </div>
    </div>
</div>
@endsection

resources/views/section/form.blade.php
<div class="form-group row">
    <label for="city" class="col-sm-4 col-form-label">Città</label>
    <div class="col-sm-8">
        <input type="text" class="form-control" name="city" value="{{ $object ? $object->city : '' }}">
    </div>
</div>
<div class="form-group row">
    <label for="prov" class="col-sm-4 col-form-label">Provincia</label>
    <div class="col-sm-8">
        @include('commons.provinces', ['name' => 'prov', 'value' => $object ? $object->prov : null])
    </div>
</div>

resources/views/section/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    @can('create', App\Section::class)
        <div class="row">
            <div class="col-md-12">
                <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#createSection">Registra Nuova</button>
                <div class="modal fade" id="createSection" tabindex="-1" role="dialog">
                    <div class="modal-dialog modal-lg" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title">Registra Sezione</h5>
                                <button type="button" class="close" data-dismiss="modal">
                                    <span>&times;</span>
                                </button>
                            </div>
                            <form method="POST" action="{{ route('section.store') }}">
                                @csrf
                                <div class="modal-body">
                                    @include('section.form', ['object' => null])
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Annulla</button>
                                    <button type="submit" class="btn btn-primary">Salva</button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    @endcan

    <div class="row mt-3">
        <div class="col-md-12">
            <table class="table">
                <thead>
                    <tr>
                        <th>Città</th>
                        <th>Provincia</th>
                        <th>Soci</th>
                        <th>Soci in regola</th>
                        <th>Altri Volontari</th>
                        <th>Disponibilità</th>

                        @if($currentuser->hasRole(['admin', 'referent']))
                            <th>Modifica</th>
                        @endif
                    </tr>
                </thead>
                <tbody>
                    @foreach($objects as $section)
                        <tr>
                            @php
                                $users_fees = $section->users()->join('fees', 'users.id', '=', 'fees.user_id')->where('fees.year', date('Y'))->count();
                            @endphp
                            <td>{{ $section->city }}</td>
                            <td>{{ $section->prov }}</td>
                            <td>{{ $section->users()->count() }}</td>
                            <td>
                            @if($users_fees < 3)
                                <span style="color:red">
                            @endif
                            {{ $users_fees }}
                            @if($users_fees < 3)
                                </span>
                            @endif
                            </td>
                            <td>{{ $section->volunteers()->count() }}</td>
                            <td>{{ $section->balance }} €</td>
                            @if($currentuser->hasRole(['admin', 'referent']))
                                <td>
                                    @can('update', $section)
                                        <a href="{{ route('section.edit', $section->id) }}"><span class="oi oi-pencil"></span></a>
                                    @endcan
                                </td>
                            @endif
                        </tr>
                    @endforeach
                </tbody>
            </table>
        </div>
    </div>
</div>
@endsection

resources/views/section/select.blade.php
<?php

if (!isset($name))
    $name = 'section[]';

if (!isset($select))
    $select = 0;

?>

<select class="form-control" name="{{ $name }}" autocomplete="off">
    <option value="0" {{ $select == 0 ? 'selected' : '0' }}>Nessuna</option>
    @foreach(App\Section::orderBy('city', 'asc')->get() as $section)
        <option value="{{ $section->id }}" {{ $select == $section->id ? 'selected' : '' }}>{{ $section->city }} ({{ $section->prov }})</option>
    @endforeach
</select>